/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 * ͒PUARTײނÇقłB
 *
 * ̧ق͒PĳUARTɊւ銮SȎ܂݂܂BUARŤ`ԐݒɂĂͯ
 *  ̧قBײނɂĕKvƂ銄荞݂𐶐̂ɊO
 * 荞݂/rv荞݂gp܂BUARTײނƂ̒ʐMSW_UAR
 * T_Enable, SW_UART_Transmit, SW_UART_Receive֐SW_UART_statusϐgp
 * ܂B\n
 * \Ȃ΁AGPIORɏ޲ĂuƂ܂BꂪUARTײނɑ΂
 * ĺޗʂ炵đx𑝂ł傤B
 *
 * \par pLq:
 *      AVR274 : PĳUART
 *
 * \par 
 * IȺގAxׁ߲A߲אݒAx޲ɂĂ
 * readme.htmlB
 *
 * \author
 *      Atmel Corporation: http://www.atmel.com \n
 *      xEҰ: avr@atmel.com
 *
 * $Name:  $
 * $Revision: 1513 $
 * $RCSfile: single_wire_UART.c,v $
 * $Date: 2007-03-29 13:17:03 +0200 (to, 29 mar 2007) $  \n
 ******************************************************************************/

#include <ioavr.h>				// ޲ŗLڼ޽/ޯĒ`
#include <inavr.h>				// __enable_interrupt()ŗLϸ
#include "stdint.h"				// ^`
#include "single_wire_UART.h"	// UARTݒ޲

/* UARTvl */
#define UART_STATE_IDLE		 0	//0+2* 0: 
#define RECEIVE_FIRST_DATA	 3	//1+2* 1: M1ް ޯ(LSB)
#define RECEIVE_LAST_DATA	17	//1+2* 8: M8ް ޯ(MSB)
#define RECEIVE_STOP_1		19	//1+2* 9: M1~ޯ
#define RECEIVE_FINISH		23	//1+2*11: Mڰъ
#define TRANSMIT_FIRST_DATA	 2	//0+2* 1: M1ް ޯ(LSB)
#define TRANSMIT_LAST_DATA	16	//0+2* 8: M8ް ޯ(MSB)
#define TRANSMIT_STOP_1		18	//0+2* 9: M1~ޯ
#define TRANSMIT_STOP_2		20	//0+2*10: M2~ޯ
#define TRANSMIT_FINISH		22	//0+2*11: Mڰъ

/* ֐^錾 */
void SW_UART_Complete_Transfer(void);
void SW_UART_Initiate_Transmission(void);

volatile uint8_t SW_UART_status;			//!< ׸ނێ޲ĕϐ
static volatile uint8_t UART_counter;		//!< rv荞݂ŎgpԔԍێ

/* ʐM֌Wϐ */
static volatile uint8_t   UART_Tx_data;		//!< Mްێ޲ĕϐ
static volatile uint8_t   UART_Rx_data;		//!< Mްێ޲ĕϐ
static volatile uint8_t   UART_Tx_buffer;	//!< Mׂްێ鑗Mޯ̧
static volatile uint8_t   UART_Rx_buffer;	//!< MްێMޯ̧

/*! \brief UART
 *
 * ̊֐/ޯ̧Aėްm邽߂ɊO
 * ݂܂BUART֐̂ǂĂԑOɂÅ֐𓮂Ƃdv
 * łBMް͎IɎMޯ̧֒u܂B
 *
 *  \note	UART/荞݂ƊO荞݂֎~邱ƂɂĒ~
 *			Ƃł܂B
 */
void SW_UART_Enable(void)
{
  INITIALIZE_UART_PIN();					// UARTݏ(Hi-Z)
//  SET_UART_PIN();							// UARTُ݂Ԃɐݒ(d(OɏՊ)gpɕKv)

  SW_UART_status = 0x00;					// UART׸ޏ
  UART_counter = UART_STATE_IDLE;			// UARTv(Ԕԍ)
  CLEAR_UART_TIMER_ON_COMPARE_MATCH();		// T/Crvł̌v(CTC)ݒ

  INITIALIZE_UART_EXTERNAL_INTERRUPT();		// O荞ݏ~[ɐݒ(JnޯČo)
  CLEAR_UART_EXTERNAL_INTERRUPT_FLAG();		// O荞ݗv׸މ(0)
  ENABLE_UART_EXTERNAL_INTERRUPT();			// O荞݋
}

/*! \brief UART֎~
 *
 * ̊֐/荞݂ƊO荞݂֎~邱ƂɂUART֎~
 * B
 */
/*
void SW_UART_Disable()
{
  SET_UART_PIN();							// UARTُ݂Ԃɐݒ
  SW_UART_status = 0x00;					// UART׸ޏ
  DISABLE_UART_TIMER_INTERRUPT();			// T/Crv荞݋֎~
  DISABLE_UART_EXTERNAL_INTERRUPT();		// O荞݋֎~
  STOP_UART_TIMER();						// /v~
}
*/

/*! \brief 1޲đM
 *
 * ̊֐Tx_dataްuAُ(UART_counter=0)ȂAM
 * 邱Ƃɂ1޲Ă𑗏o܂B
 *
 *  \note	̊֐Ă΂鎞SW_UART_TX_BUFFER_FULL׸ނ0łȂ΂Ȃ
 *			BȂƑMް܂B
 *
 *  \param  data	ׂް
 */
void SW_UART_Transmit(uint8_t data)
{
  SET_FLAG( SW_UART_status, SW_UART_TX_BUFFER_FULL );		// Mޯ̧t׸ސݒ(1)
  UART_Tx_buffer = data;									// Mް𑗐Mޯ̧֕

  if( UART_counter == UART_STATE_IDLE )						// ײނُԂŁA
  {
	UART_Tx_data = UART_Tx_buffer;							// Mޯ̧l𑗐Mꎞl֕
	CLEAR_FLAG( SW_UART_status, SW_UART_TX_BUFFER_FULL );	// Mޯ̧t׸މ(0)

	DISABLE_UART_EXTERNAL_INTERRUPT();						// O荞݋֎~
	CLEAR_UART_PIN();										// UART=Lowo(Jnޯ)
	UART_counter = TRANSMIT_FIRST_DATA;						// ײޏԔԍ擪ް ޯđMԂɕύX
	CLEAR_UART_TIMER();										// T/Cl(=0)
	SET_UART_TIMER_COMPARE_START_TRANSMIT();				// T/CrlޯđMpɐݒ
	CLEAR_UART_TIMER_INTERRUPT_FLAG();						// T/Crv荞ݗv׸މ
	ENABLE_UART_TIMER_INTERRUPT();							// T/Crv荞݋
	START_UART_TIMER();										// /vJn
  }
}

/*! \brief 1޲ĎM
 *
 * ̊֐͎Mޯ̧𱸾邱Ƃɂ1޲ĂްM܂B
 *
 *  \note	̊֐Ă΂鎞SW_UART_RX_BUFFER_FULL׸ނ1łȂ΂Ȃ
 *			B
 *
 *  \return	Mް
 */
uint8_t SW_UART_Receive(void)
{
  uint8_t data;

  data = UART_Rx_buffer;								// Mޯ̧l𕡎
  CLEAR_FLAG( SW_UART_status, SW_UART_RX_BUFFER_FULL );	// Mޯ̧t׸ނ(0)
  return data;											// MlƋɕA
}

/*! \brief O荞ݏٰ
 *
 * JnޯĂ̐擪ł̉~[̊荞݂N܂BޯĂMׂ
 * ް ޯĂł邱Ƃ}邽߁AT/Crv荞݂AUARTv
 * (Ԕԍ)RECEIVE_FIRST_DATAɐݒ肳܂B
 */
#pragma vector=SW_UART_EXTERNAL_INTERRUPT_VECTOR
__interrupt void External_SW_UART_ISR(void)
{
  if(!READ_UART_PIN())						// UART=LowŁA(JnޯĊmF)
  {
	UART_counter = RECEIVE_FIRST_DATA;		// UARTv(Ԕԍ)ް ޯĎMɕύX
	UART_Rx_data = 0x00;					// Mꎞl
	STOP_UART_TIMER();						// /v~(OuؾĂmɂ邽)
	CLEAR_UART_TIMER();						// T/Cl(=0)
	SET_UART_TIMER_COMPARE_START_RECEIVE();	// T/CrlޯĎMpɐݒ(ްLSB̎)
	DISABLE_UART_EXTERNAL_INTERRUPT();		// O荞݋֎~
	CLEAR_UART_TIMER_INTERRUPT_FLAG();		// T/Crv荞ݗv׸މ
	ENABLE_UART_TIMER_INTERRUPT();			// T/Crv荞݋
	START_UART_TIMER();						// /vJn
  }
}

/*! \brief /rv荞ݏٰ
 *
 * ̊荞݂͔rڼ޽vlƓɋN܂BeޯĂ̑M
 * UARTv(Ԕԍ)i߂܂B
 *
 *  \note	WAIT_ONE`ٰ݂͂Ŕ₳ő厞Ԃ傫Ȃ΂Ȃ
 *			Âߊ荞݂͎܂B
 */
#pragma vector=SW_UART_TIMER_COMPARE_INTERRUPT_VECTOR
__interrupt void Timer_SW_UART_ISR(void)
{
  SET_UART_TIMER_COMPARE_WAIT_ONE();		//!< T/Crl1ޯĎԂɐݒ

  uint8_t bit_in = 0x00;					// UARTݎ擾l
  if(READ_UART_PIN())						// UART=HighŁA
  {
	bit_in = 0x01;							// UARTݎ擾l=1
  }

//	* M (UARTv=) *

  if(UART_counter & 0x01)					// MŁA
  {
	if(UART_counter <= RECEIVE_LAST_DATA)		// ް ޯĎMԂŁA
	{
	  UART_Rx_data = ( UART_Rx_data >> 1 );			// MꎞlE1ޯĈړ,0MSB
	  if(bit_in)									// UARTݎ擾l=1ŁA
	  {
		UART_Rx_data |= 0x80;						// MꎞlMSB=1
	  }
	}
	else if(UART_counter == RECEIVE_STOP_1)		// 1~ޯĎMԂŁA
	{
	  if(!bit_in)									// UARTݎ擾l=0ŁA
	  {
		SET_FLAG( SW_UART_status, SW_UART_FRAME_ERROR );	// ڰݸތ׸ސݒ(1)
		// (KvȂT/C~ĎM֎~ĂB)
	  }
	  if( READ_FLAG(SW_UART_status, SW_UART_RX_BUFFER_FULL))	// Mޯ̧󂫂ȂŁA
	  {
		SET_FLAG(SW_UART_status, SW_UART_RX_BUFFER_OVERFLOW);	// Mޯ̧׸ސݒ(1)
	  }
	  UART_Rx_buffer = UART_Rx_data;						// MlMޯ̧֊i[
	  SET_FLAG( SW_UART_status, SW_UART_RX_BUFFER_FULL );	// Mޯ̧t׸ސݒ(1)
	  CLEAR_UART_EXTERNAL_INTERRUPT_FLAG();					// O荞ݗv׸މ(0)
	  ENABLE_UART_EXTERNAL_INTERRUPT();						// O荞݋(JnޯČop)
	}
	else if(UART_counter == RECEIVE_FINISH)		// M(̊JnޯĂȂ)ԂŁA
	{
	  if( READ_FLAG(SW_UART_status, SW_UART_TX_BUFFER_FULL) )	// Mްς݂ŁA
	  {															// (MԂ֐؂ւ)
		UART_Tx_data = UART_Tx_buffer;							// Mޯ̧l𑗐Mꎞl֕
		CLEAR_FLAG( SW_UART_status, SW_UART_TX_BUFFER_FULL );	// Mޯ̧t׸މ(0)
		DISABLE_UART_EXTERNAL_INTERRUPT();						// O荞݋֎~
		CLEAR_UART_PIN();										// UART=Lowo(Jnޯ)
		UART_counter = TRANSMIT_FIRST_DATA;						// ײޏԔԍ擪ް ޯđMԂɕύX
		STOP_UART_TIMER();										// /v~(OuؾĂmɂ邽)
		CLEAR_UART_TIMER();										// T/Cl(=0)
		SET_UART_TIMER_COMPARE_START_TRANSMIT();				// T/CrlޯđMpɐݒ
		CLEAR_UART_TIMER_INTERRUPT_FLAG();						// T/Crv荞ݗv׸މ
		START_UART_TIMER();										// /vJn
		return;													// UARTv̐is邽߁AŕA
      }
	  else														// MްȂŁA
	  {
		STOP_UART_TIMER();										// /v~
		DISABLE_UART_TIMER_INTERRUPT();							// T/Crv荞݋֎~
		UART_counter = UART_STATE_IDLE;							// UARTv(Ԕԍ)قɕύX
		return;													// UARTv̐is邽߁AŕA
	  }
	}
  }

//	* M (UARTv=) *

  else										// MŁA
  {
	uint8_t bit_out = 0x00;					// UARTݏo͒l

	if(UART_counter != TRANSMIT_FIRST_DATA)		// ް ޯďԈȊOŁA
	{											// (޽Փˌ)
	  uint8_t last_bit_sent = 0x01;				// Oo͒lƂ1(~ޯ)ݒ

	  if(UART_counter <= TRANSMIT_STOP_1)		// Oް ޯĂŁA
	  {
		last_bit_sent = UART_Tx_data & 0x01;	// Oo͒lۑ
		UART_Tx_data = UART_Tx_data >> 1;		// MꎞlE1ޯĈړ
	  }
	  if( last_bit_sent != bit_in )				// ݒlOo͒lƈႦ΁A
	  {
		SET_FLAG(SW_UART_status, SW_UART_FRAME_ERROR);	// ڰݸތ׸ސݒ(1)
		// (KvȂΑM𒆎~ĂB)
	  }
	}
	if(UART_counter <= TRANSMIT_LAST_DATA)		// ް ޯđMԂŁA
	{
	  if( UART_Tx_data & 0x01 )						// ol=1ŁA
	  {
		bit_out = 0x01;								// UARTݏo͒l=1ݒ
	  }
	}
	else if(UART_counter == TRANSMIT_STOP_1)	// 1~ޯđMԂŁA
	{
	  bit_out = 0x01;								// UARTݏo͒l=1ݒ
	}
	else if(UART_counter == TRANSMIT_STOP_2)	// 2~ޯđMԂŁA
	{
	  CLEAR_UART_EXTERNAL_INTERRUPT_FLAG();			// O荞ݗv׸މ(0)
	  ENABLE_UART_EXTERNAL_INTERRUPT();				// O荞݋(̎_M)
	  bit_out = 0x01;								// UARTݏo͒l=1ݒ
	}
	else										// MԂŁA
	{
	  if(!READ_FLAG(SW_UART_status, SW_UART_TX_BUFFER_FULL))	// MްȂŁA
	  {
		STOP_UART_TIMER();											// /v~
		DISABLE_UART_TIMER_INTERRUPT();								// T/Crv荞݋֎~
		UART_counter = UART_STATE_IDLE;								// UARTv(Ԕԍ)قɕύX
		return;														// UARTv̐is邽߁AŕA
	  }
	  else														// Mްς݂ŁA
	  {
		UART_Tx_data = UART_Tx_buffer;								// Mޯ̧l𑗐Mꎞl֕
		CLEAR_FLAG( SW_UART_status, SW_UART_TX_BUFFER_FULL );		// Mޯ̧t׸މ(0)
		UART_counter = TRANSMIT_FIRST_DATA - 2;						// ײޏԔԍ擪ް ޯđMԂɕύX(ȍ~+2̂-2Kv)
		DISABLE_UART_EXTERNAL_INTERRUPT();							// O荞݋֎~
		// ('bit_out = 0'(Jnޯėpo͒l)͊ɉݒƂ0Ȃ̂ŏȗ)
	  }
	}

	if( bit_out )						// UARTݏo͒l=1ŁA
	{
	  SET_UART_PIN();					// UART݂Hi-Z()ݒ
	}
	else								// UARTݏo͒l=0ŁA
	{
	  CLEAR_UART_PIN();					// UART݂Lowo͐ݒ
	}
  }
  UART_counter = UART_counter + 2;		// UARTv(Ԕԍ)is(+2)
}
